package code;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.Behaviour;

import jade.core.behaviours.TickerBehaviour;
import jade.core.behaviours.WakerBehaviour;
import jade.lang.acl.ACLMessage;

public class AlbanilBehaviours{

	public static class BocadilloBehaviour extends WakerBehaviour{

		public BocadilloBehaviour(Agent a, long timeout) {
			super(a, timeout);
		}
		
        public void onStart() {
    	    System.out.println("Agente ["+myAgent.getLocalName()+" 'El Albail'] ha llegado a la construccion.");
    	    System.out.println("----------------------------------------------------------");
    	    myAgent.doWait(2000); // 2000 milisegundos = 2 segundos
    	    super.onStart();
        } 
        
		//Comportamiento nico- Pasado X tiempo realiza una slo vez la accin -> onWake(), X miliseg.
		protected void onWake(){
			
			System.out.println(myAgent.getLocalName()+" 'El Albail': Hora del bocadillo!");
			ACLMessage aviso = new ACLMessage(ACLMessage.REQUEST);
			AID aidBl2 = new AID();
			aidBl2.setLocalName("Goyo");
			aviso.addReceiver(aidBl2);
			aviso.setSender(myAgent.getAID());
			aviso.setContent("relax");
			myAgent.send(aviso);
			
			//Se bloquea entero el agente hasta recibir un mensaje REQUEST.
			myAgent.blockingReceive();  
			myAgent.doWait(2000);
			System.out.println(myAgent.getLocalName()+" 'El Albail': Uy, que susto! Voy jefe!");
			myAgent.doWait(1000);
			
		}//fin onWake()
		
	} // fin BocadilloBehaviour
	
	public static class LadrilloBehaviour extends TickerBehaviour{
		
		private int ladrillos = 1;
		private int paredes = 1;
		private ACLMessage msg;

		public LadrilloBehaviour(Agent a, long timeout) {
			super(a, timeout);
		}
        
        //Comportamiento ciclico- Cada X tiempo realiza una accion -> onTick(),  X miliseg
        protected void onTick(){ 
        	
        	msg = myAgent.receive();
        	if(msg!=null){
        		
				if(msg.getContent().equals("casa")){
					System.out.println(myAgent.getLocalName()+" 'El Albail': Yujuuu! Agur.");
					myAgent.doDelete();
				}
				
        	}else{
        		
    			switch(ladrillos){
					case 1:
						System.out.println(myAgent.getLocalName()+" 'El Albail': "+ladrillos+" ladrillo...");
						ladrillos++;
						break;
					default:
						System.out.println(myAgent.getLocalName()+" 'El Albail': "+ladrillos+" ladrillos...");
						ladrillos++;
						break;
					case 6:
						System.out.println(myAgent.getLocalName()+" 'El Albail': Pared "+paredes+" completa.");
						ladrillos = 1;
						paredes++;
						break;
    			}
    			
        	}//fin else
    
		} //fin onTick()
		
	} // fin LadrilloBehaviour 
	
	public static class CementoBehaviour extends TickerBehaviour{
		private int cementoStep = 1;
		private int piropos = 1;
		
		public CementoBehaviour(Agent a, long period) {
			super(a, period);
		}
		
        public void onStart() {
    	    System.out.println("Agente ["+myAgent.getLocalName()+" 'El Albail'] ha llegado a la construccion.");
    	    System.out.println("----------------------------------------------------------");
    	    myAgent.doWait(2000); // 2000 milisegundos = 2 segundos
    	    super.onStart();  	    
        }

		protected void onTick() {

    			switch(cementoStep){
					case 1:
						System.out.println(myAgent.getLocalName()+" 'El Albail': Hormigonera vacia, haciendo cemento...");
						cementoStep++;
						break;
					case 2:
						System.out.println(myAgent.getLocalName()+" 'El Albail': 'Amasandooo, amasandooo, y con el mazo dandooo... oohh, oohh, ooohhh' ");
						cementoStep++;
						break;
					case 3:
						System.out.println(myAgent.getLocalName()+" 'El Albail': Cemento listo!");
						cementoStep++;
						break;
					case 4:
						
						switch(piropos){
							case 1:
								System.out.println(myAgent.getLocalName()+" 'El Albail': Hey, guapa! Si fueras un bollicao, me coma hasta la pegatina!");
								piropos++;
								break;
							case 2:
								System.out.println(myAgent.getLocalName()+" 'El Albail': Fiuuu! Fiuuu! Eso son muslos y no los del pollo!");
								piropos++;
								break;
							case 3:
								System.out.println(myAgent.getLocalName()+" 'El Albail': Esa moza! Quien fuera cemento pa' sujetar ese monumento!");
								piropos++;
								break;
							case 4:
								System.out.println(myAgent.getLocalName()+" 'El Albail': Vivan las chicas bonitas! Tu madre debe ser pastelera, porque un bombn as no lo hace cualquiera!");
								piropos=1;
								break;
						}
						cementoStep=1;
						break;
    			} //fin switch cemento
    			    						
		} //fin onTick()
		
	}//fin CementoBehaviour
	
	/** SiestaBehaviour = ThreeStepBehaviour **/
	public static class SiestaBehaviour extends Behaviour{
		private int step = 1;
		private ACLMessage msg;
		private Behaviour cb;
		
		public SiestaBehaviour(Behaviour b){
			cb = b;
		}
		
		public void onStart(){
			msg = myAgent.receive();
			while (msg==null){
				msg = myAgent.receive();
			}
			myAgent.removeBehaviour(cb);
		}
		
		public void action() {
								
			if(msg!=null){

        		if(msg.getContent().equals("relax")){
					
					switch(step){
						case 1:
							step++;
							block();
							myAgent.doWait(1000);
							System.out.println(myAgent.getLocalName()+" 'El Albail': Pues yo me voy a echar una siesta.");
							myAgent.doWait(2500);
							System.out.println(myAgent.getLocalName()+" 'El Albail': zzzZZZzzzZZZzzzZZZzzz...");
							myAgent.doWait(2500);
							System.out.println(myAgent.getLocalName()+" 'El Albail': ZZZzzzZZZzzzZZZzzzZZZ...");
							myAgent.doWait(2500);
							System.out.println(myAgent.getLocalName()+" 'El Albail': zzzZZZzzzZZZzzzZZZzzz...");
							myAgent.doWait(2500);
							System.out.println(myAgent.getLocalName()+" 'El Albail': ZZZzzzZZZzzzZZZzzzZZZ...");
							myAgent.doWait(2500);
							System.out.println(myAgent.getLocalName()+" 'El Albail': zzzZZZzzzZZZzzzZZZzzz...");
							break;
						case 2:
							step++;
							myAgent.doWait(1850);
							System.out.println(myAgent.getLocalName()+" 'El Albail': Hostia! No estoy dormido! No estoy dormido!");
							myAgent.doWait(1000);
							myAgent.addBehaviour(cb);
							block();
							break;
						case 3:
							step++;
							myAgent.doWait(2500);
							System.out.println(myAgent.getLocalName()+" 'El Albail': Por fin! Pues, para casita!");
							break;					
					} // fin switch
					
				} // fin if-relax
				
        	} // fin if-null
			
		} // fin action()

		public boolean done() {
			return step == 4;
		}
		
		public int onEnd(){
			System.out.println("Agente ["+myAgent.getLocalName()+ " 'El Albail'] se ha ido.");
    	    System.out.println("----------------------------------------------------------");
			myAgent.doDelete();
			return super.onEnd();
		}
		
	} // fin SiestaBehaviour	
	
	
}
